searchNodes=[{"doc":"","ref":"SiteEncrypt.html","title":"SiteEncrypt","type":"behaviour"},{"doc":"Invoked during startup to obtain certification info.See configure/1 for details.","ref":"SiteEncrypt.html#c:certification/0","title":"SiteEncrypt.certification/0","type":"callback"},{"doc":"Invoke this macro from certification/0 to return the fully shaped configuration.The minimal implementation of certification/0 looks as follows:@impl SiteEncrypt def certification do SiteEncrypt.configure( client: :native, domains: [&quot;mysite.com&quot;, &quot;www.mysite.com&quot;], emails: [&quot;contact@abc.org&quot;, &quot;another_contact@abc.org&quot;], db_folder: Application.app_dir(:phoenix_demo, Path.join(~w/priv site_encrypt/)) # set OS env var MODE to &quot;staging&quot; or &quot;production&quot; on staging/production hosts directory_url: case System.get_env(&quot;MODE&quot;, &quot;local&quot;) do &quot;local&quot; -&gt; {:internal, port: 4002} &quot;staging&quot; -&gt; &quot;https://acme-staging-v02.api.letsencrypt.org/directory&quot; &quot;production&quot; -&gt; &quot;https://acme-v02.api.letsencrypt.org/directory&quot; end ) endOptions:client - Required. Can be either :native or :certbot.The native client requires no extra OS-level dependencies, and it runs faster, which is especially useful in a local development and tests. However, this client is very immature, possibly buggy, and incomplete.The certbot client is a wrapper around the certbot tool, which has to be installed on the host machine. This client is much more reliable than the native client, but it is also significantly slower.As a compromise between these two choices, you can consider running certbot client in production and during CI tests, while using the native client for local development and local tests.:domains - Required. The list of domains for which the certificate will be obtained. Must contain at least one element.:emails - Required. The list of email addresses which will be passed to the CA when creating the new account.:db_folder - Required. The folder where site_encrypt stores its data, such as certificates and account keys.:directory_url - Required. The URL to CA directory resource. It can be either a string (e.g. &quot;https://acme-v02.api.letsencrypt.org/directory&quot;) or a tuple in the shape of {:internal, port: local_acme_server_port}. In the latter case, an internal ACME server will be started at the given port. This is useful for local development and testing.:backup - Path to the backup file. If this option is provided, site_encrypt will backup the entire content of the :db_folder to the given path after every successful certification. When the system is being started, if the backup file exists while the :db_folder is empty, the system will perform a restore. The generated file will be a zipped tarball. If this option is not provided no backup will be generated.:days_to_renew - A positive integer which determines the next renewal attempt. For example, if this value is 30, the certificate will be renewed if it expires in 30 days or less. The default value is 30.:log_level - Logger level for info messages. The default value is :info.","ref":"SiteEncrypt.html#configure/1","title":"SiteEncrypt.configure/1","type":"macro"},{"doc":"Force renews the certificate for the given site.Be very careful when invoking this function in production, because you might trip some rate limit at the CA server (see here for Let's Encrypt limits).","ref":"SiteEncrypt.html#force_renew/1","title":"SiteEncrypt.force_renew/1","type":"function"},{"doc":"Invoked after the new certificate has been obtained.","ref":"SiteEncrypt.html#c:handle_new_cert/0","title":"SiteEncrypt.handle_new_cert/0","type":"callback"},{"doc":"Returns the paths to the certificates and the key for the given site.","ref":"SiteEncrypt.html#https_keys/1","title":"SiteEncrypt.https_keys/1","type":"function"},{"doc":"","ref":"SiteEncrypt.html#t:certification/0","title":"SiteEncrypt.certification/0","type":"opaque"},{"doc":"Uniquely identifies the site certified via site_encrypt.The actual value is determined by the adapter used to start the site. For example, if SiteEncrypt.Phoenix is used, the site id is the endpoint module.","ref":"SiteEncrypt.html#t:id/0","title":"SiteEncrypt.id/0","type":"type"},{"doc":"SiteEncrypt adapter for Phoenix endpoints.UsageAdd use SiteEncrypt.Phoenix to your endpoint immediately after use Phoenix.EndpointConfigure https via configure_https/2.Add the implementation of SiteEncrypt.certification/0 to the endpoint (the @behaviour SiteEncrypt is injected when this module is used).","ref":"SiteEncrypt.Phoenix.html","title":"SiteEncrypt.Phoenix","type":"module"},{"doc":"Merges paths to key and certificates to the :https configuration of the endpoint config.Invoke this macro from Phoenix.Endpoint.init/2 to complete the https configuration:defmodule MyEndpoint do # ... @impl Phoenix.Endpoint def init(_key, config) do # this will merge key, cert, and chain into `:https` configuration from config.exs {:ok, SiteEncrypt.Phoenix.configure_https(config)} # to completely configure https from `init/2`, invoke: # SiteEncrypt.Phoenix.configure_https(config, port: 4001, ...) end # ... endThe options are any valid adapter HTTPS options. For many great tips on configuring HTTPS for production refer to the Plug HTTPS guide.","ref":"SiteEncrypt.Phoenix.html#configure_https/2","title":"SiteEncrypt.Phoenix.configure_https/2","type":"macro"},{"doc":"Helper for testing the certification.Usagedefmodule MyEndpoint.CertificationTest do use ExUnit.Case, async: false import SiteEncrypt.Phoenix.Test test &quot;certification&quot; do clean_restart(MyEndpoint) cert = get_cert(MyEndpoint) assert cert.domains == ~w/mysite.com www.mysite.com/ end endFor this to work, you need to use the internal ACME server during tests. Refer to SiteEncrypt.configure/1 for details.Also note that this test will restart the endpoint. In addition, it will configure Phoenix to serve the traffic. Therefore, make sure you pick a different set of ports in test, if you want to be able to run the tests while the system is started.Due to endpoint being restarted, the test case has to be marked as async: false.","ref":"SiteEncrypt.Phoenix.Test.html","title":"SiteEncrypt.Phoenix.Test","type":"module"},{"doc":"Restarts the endpoint, removing all site_encrypt folders in the process.After the restart, the new certificate will be obtained.","ref":"SiteEncrypt.Phoenix.Test.html#clean_restart/1","title":"SiteEncrypt.Phoenix.Test.clean_restart/1","type":"function"},{"doc":"Obtains the certificate for the given endpoint.The certificate is obtained by establishing an SSL connection. Therefore, for this function to work, the endpoint has to be serving traffic. This will happen if you previously invoked clean_restart/1.","ref":"SiteEncrypt.Phoenix.Test.html#get_cert/1","title":"SiteEncrypt.Phoenix.Test.get_cert/1","type":"function"},{"doc":"SiteEncrypt This project aims to provide integrated certification via Let's encrypt for sites implemented in Elixir.Integrated certification means that you don't need to run any other OS process in background. Start your site for the first time, and the system will obtain the certificate, and periodically renew it before it expires.The target projects are small-to-medium Elixir based sites which don't sit behind reverse proxies such as nginx.","ref":"readme.html","title":"SiteEncrypt","type":"extras"},{"doc":"The library is tested in a simple production, where it has been constantly running since mid 2018.Native Elixir client is very new, and not considered stable. If you prefer reliable behaviour, use the Certbot client. This will require installing Certbot &gt;= 0.31The API is not stable. Expect breaking changes in the future.","ref":"readme.html#status","title":"SiteEncrypt - Status","type":"extras"},{"doc":"A basic demo Phoenix project is available here.Add the dependency to mix.exs: defmodule PhoenixDemo.Mixfile do # ... defp deps do [ # ... {:site_encrypt, &quot;~&gt; 0.2.0&quot;} ] end end Don't forget to invoke mix.deps after that.Expand your endpoint defmodule PhoenixDemo.Endpoint do # ... # add this after `use Phoenix.Endpoint` use SiteEncrypt.Phoenix # ... @impl SiteEncrypt def certification do SiteEncrypt.configure( # Note that native client is very immature. If you want a more stable behaviour, you can # provide `:certbot` instead. Note that in this case certbot needs to be installed on the # host machine. client: :native, domains: [&quot;mysite.com&quot;, &quot;www.mysite.com&quot;], emails: [&quot;contact@abc.org&quot;, &quot;another_contact@abc.org&quot;], db_folder: Application.app_dir(:phoenix_demo, Path.join(~w/priv site_encrypt/)), # set OS env var MODE to &quot;staging&quot; or &quot;production&quot; on staging/production hosts directory_url: case System.get_env(&quot;MODE&quot;, &quot;local&quot;) do &quot;local&quot; -&gt; {:internal, port: 4002} &quot;staging&quot; -&gt; &quot;https://acme-staging-v02.api.letsencrypt.org/directory&quot; &quot;production&quot; -&gt; &quot;https://acme-v02.api.letsencrypt.org/directory&quot; end ) end # ... endConfigure https: defmodule PhoenixDemo.Endpoint do # ... @impl Phoenix.Endpoint def init(_key, config) do # this will merge key, cert, and chain into `:https` configuration from config.exs {:ok, SiteEncrypt.Phoenix.configure_https(config)} # to completely configure https from `init/2`, invoke: # SiteEncrypt.Phoenix.configure_https(config, port: 4001, ...) end # ... endStart the endpoint via SiteEncrypt: defmodule PhoenixDemo.Application do use Application def start(_type, _args) do children = [{SiteEncrypt.Phoenix, PhoenixDemo.Endpoint}] opts = [strategy: :one_for_one, name: PhoenixDemo.Supervisor] Supervisor.start_link(children, opts) end # ... endOptionally add a certification test defmodule PhoenixDemo.Endpoint.CertificationTest do use ExUnit.Case, async: false import SiteEncrypt.Phoenix.Test test &quot;certification&quot; do clean_restart(PhoenixDemo.Endpoint) cert = get_cert(PhoenixDemo.Endpoint) assert cert.domains == ~w/mysite.com www.mysite.com/ end endAnd that's it! At this point you can start the system:$ iex -S mix phx.server [info] Generating a temporary self-signed certificate. This certificate will be used until a proper certificate is issued by the CA server. [info] Running PhoenixDemo.Endpoint with cowboy 2.7.0 at 0.0.0.0:4000 (http) [info] Running PhoenixDemo.Endpoint with cowboy 2.7.0 at 0.0.0.0:4001 (https) [info] Running local ACME server at port 4002 [info] Ordering a new certificate for domain mysite.com [info] New certificate for domain mysite.com obtained [info] Certificate successfully obtained! It is valid until 3019-09-27. Next renewal is scheduled for 3019-08-28.And visit your certified site at https://localhost:4001","ref":"readme.html#quick-start","title":"SiteEncrypt - Quick start","type":"extras"},{"doc":"MIT","ref":"readme.html#license","title":"SiteEncrypt - License","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Breaking changesThe interface for writing tests has been changed. A certification test should now be written as defmodule MyEndpoint.CertificationTest do use ExUnit.Case, async: false import SiteEncrypt.Phoenix.Test test &quot;certification&quot; do clean_restart(MyEndpoint) cert = get_cert(MyEndpoint) assert cert.domains == ~w/mysite.com www.mysite.com/ end end","ref":"changelog.html#0-2-0","title":"Changelog - 0.2.0","type":"extras"},{"doc":"added a basic native ACME clientsimplified interfaceimproved testsexpanded docsThis version introduces many breaking changes. If you've been using a pre 0.1 version, here's how to upgrade your project:In your endpoint, replace @behaviour SiteEncrypt with use SiteEncrypt.PhoenixAlso in the endpoint, change the certification/0 callback to pass the options to SiteEncrypt.configure/1 instead of just returning them.Changes in options::mode is no longer supported. Manual mode will be automatically set in tests.use :domains instead of :domain and :extra_domain:ca_url has been renamed to directory_url:email has been renamed to emails and must be a list:base_folder has been renamed to :db_folder:cert_folder is no longer supported. It will chosen automatically inside the :db_folderThe internal folders structure has been changed. If you're running a site_encrypt system in production, you need to create the folder called certbot inside the :db_folder, and recurisvely copy top-level folders under :db_folder into the newly created certbot folder.If you have been using SiteEncrypt.Phoenix.Test.verify_certification for certification testing, drop that test, and add the following module somewhere in your test suite: defmodule CertificationTest do use SiteEncrypt.Phoenix.Test, endpoint: MyEndpoint end","ref":"changelog.html#0-1-0","title":"Changelog - 0.1.0","type":"extras"}]